{
  open Ppparser        (* The type token is defined in parser.mli *)
}

rule token = parse
  [' ' '\t' '\n']     { token lexbuf }     (* skip blanks *)
| '['            { LSQUARE }
| ']'            { RSQUARE }
| '('            { LPAREN }
| ')'            { RPAREN }
| '.'            { DOT }
| "top"          { TOP }
| "==>"           { ARROW }
| ','            { COMMA }
| "var"          { VAR }
| "lam"          { LAM }
| "app"          { APP }
| "tlam"         { TLAM }
| "tapp"         { TAPP }
| "rcd"          { RCD }
| "proj"         { PROJ }
| "patt"         { PATT }
| "pvar"         { PVAR }
| "prcd"         { PRCD }
| "pterm1"       { PTERM1 }
| "pterm2"       { PTERM2 }
| "tvar"         { TVAR }
| "tall"         { TALL }
| "trcd"         { TRCD }
| '\\'            { SLASH }
| (['a'-'z' 'A'-'Z'] ['A'-'Z' 'a'-'z' '0'-'9']* '_'?) as x  { LCID x }
| (['A'-'Z'] (['A'-'Z' 'a'-'z' '0'-'9']*)) as x { UCID x }
| '\"'(['a'-'z' 'A'-'Z' '0'-'9']* as x)'\"' { LABEL x }
| eof            { EOF }
